Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90	(revision 7309)
@@ -18,17 +18,15 @@
    USE thd_ice          ! LIM thermodynamics
    USE ice              ! LIM variables
-   USE dom_ice          ! LIM domain
    USE limvar           ! LIM
    USE lbclnk           ! lateral boundary condition - MPP exchanges
    USE lib_mpp          ! MPP library
    USE wrk_nemo         ! work arrays
-   USE prtctl           ! Print control
 
    USE in_out_manager   ! I/O manager
    USE iom              ! I/O manager
    USE lib_fortran      ! glob_sum
-   USE limdiahsb
    USE timing           ! Timing
    USE limcons          ! conservation tests
+   USE limctl           ! control prints
 
    IMPLICIT NONE
@@ -70,10 +68,9 @@
       !!                ***  ROUTINE lim_itd_me_alloc ***
       !!---------------------------------------------------------------------!
-      ALLOCATE(                                                                     &
+      ALLOCATE(                                                                      &
          !* Variables shared among ridging subroutines
-         &      asum (jpi,jpj)     , athorn(jpi,jpj,0:jpl)                    ,     &
-         &      aksum(jpi,jpj)                                                ,     &
-         &      hrmin(jpi,jpj,jpl) , hraft(jpi,jpj,jpl) , aridge(jpi,jpj,jpl) ,     &
-         &      hrmax(jpi,jpj,jpl) , krdg (jpi,jpj,jpl) , araft (jpi,jpj,jpl) , STAT=lim_itd_me_alloc )
+         &      asum (jpi,jpj)     , athorn(jpi,jpj,0:jpl) , aksum (jpi,jpj)     ,   &
+         &      hrmin(jpi,jpj,jpl) , hraft(jpi,jpj,jpl)    , aridge(jpi,jpj,jpl) ,   &
+         &      hrmax(jpi,jpj,jpl) , krdg (jpi,jpj,jpl)    , araft (jpi,jpj,jpl) , STAT=lim_itd_me_alloc )
          !
       IF( lim_itd_me_alloc /= 0 )   CALL ctl_warn( 'lim_itd_me_alloc: failed to allocate arrays' )
@@ -127,13 +124,6 @@
       CALL wrk_alloc( jpi,jpj, closing_net, divu_adv, opning, closing_gross )
 
-      IF(ln_ctl) THEN
-         CALL prt_ctl(tab2d_1=ato_i , clinfo1=' lim_itd_me: ato_i  : ', tab2d_2=at_i   , clinfo2=' at_i    : ')
-         CALL prt_ctl(tab2d_1=divu_i, clinfo1=' lim_itd_me: divu_i : ', tab2d_2=delta_i, clinfo2=' delta_i : ')
-      ENDIF
-
-      IF( ln_limdyn ) THEN          !   Start ridging and rafting   !
-
       ! conservation test
-      IF( ln_limdiahsb ) CALL lim_cons_hsm(0, 'limitd_me', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+      IF( ln_limdiachk ) CALL lim_cons_hsm(0, 'limitd_me', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
 
       !-----------------------------------------------------------------------------!
@@ -211,9 +201,9 @@
             DO ji = 1, jpi
                za   = ( opning(ji,jj) - athorn(ji,jj,0) * closing_gross(ji,jj) ) * rdt_ice
-               IF( za < 0._wp .AND. za > - ato_i(ji,jj) ) THEN  ! would lead to negative ato_i
-                  zfac = - ato_i(ji,jj) / za
+               IF    ( za < 0._wp .AND. za > - ato_i(ji,jj) ) THEN                  ! would lead to negative ato_i
+                  zfac          = - ato_i(ji,jj) / za
                   opning(ji,jj) = athorn(ji,jj,0) * closing_gross(ji,jj) - ato_i(ji,jj) * r1_rdtice 
                ELSEIF( za > 0._wp .AND. za > ( asum(ji,jj) - ato_i(ji,jj) ) ) THEN  ! would lead to ato_i > asum
-                  zfac = ( asum(ji,jj) - ato_i(ji,jj) ) / za
+                  zfac          = ( asum(ji,jj) - ato_i(ji,jj) ) / za
                   opning(ji,jj) = athorn(ji,jj,0) * closing_gross(ji,jj) + ( asum(ji,jj) - ato_i(ji,jj) ) * r1_rdtice 
                ENDIF
@@ -259,4 +249,5 @@
                   closing_net(ji,jj) = 0._wp
                   opning     (ji,jj) = 0._wp
+                  ato_i      (ji,jj) = MAX( 0._wp, 1._wp - SUM( a_i(ji,jj,:) ) )
                ELSE
                   iterate_ridging    = 1
@@ -292,43 +283,10 @@
       ! control prints
       !-----------------------------------------------------------------------------!
-      IF(ln_ctl) THEN 
-         CALL lim_var_glo2eqv
-
-         CALL prt_ctl_info(' ')
-         CALL prt_ctl_info(' - Cell values : ')
-         CALL prt_ctl_info('   ~~~~~~~~~~~~~ ')
-         CALL prt_ctl(tab2d_1=e1e2t , clinfo1=' lim_itd_me  : cell area :')
-         CALL prt_ctl(tab2d_1=at_i , clinfo1=' lim_itd_me  : at_i      :')
-         CALL prt_ctl(tab2d_1=vt_i , clinfo1=' lim_itd_me  : vt_i      :')
-         CALL prt_ctl(tab2d_1=vt_s , clinfo1=' lim_itd_me  : vt_s      :')
-         DO jl = 1, jpl
-            CALL prt_ctl_info(' ')
-            CALL prt_ctl_info(' - Category : ', ivar1=jl)
-            CALL prt_ctl_info('   ~~~~~~~~~~')
-            CALL prt_ctl(tab2d_1=a_i   (:,:,jl)   , clinfo1= ' lim_itd_me  : a_i      : ')
-            CALL prt_ctl(tab2d_1=ht_i  (:,:,jl)   , clinfo1= ' lim_itd_me  : ht_i     : ')
-            CALL prt_ctl(tab2d_1=ht_s  (:,:,jl)   , clinfo1= ' lim_itd_me  : ht_s     : ')
-            CALL prt_ctl(tab2d_1=v_i   (:,:,jl)   , clinfo1= ' lim_itd_me  : v_i      : ')
-            CALL prt_ctl(tab2d_1=v_s   (:,:,jl)   , clinfo1= ' lim_itd_me  : v_s      : ')
-            CALL prt_ctl(tab2d_1=e_s   (:,:,1,jl) , clinfo1= ' lim_itd_me  : e_s      : ')
-            CALL prt_ctl(tab2d_1=t_su  (:,:,jl)   , clinfo1= ' lim_itd_me  : t_su     : ')
-            CALL prt_ctl(tab2d_1=t_s   (:,:,1,jl) , clinfo1= ' lim_itd_me  : t_snow   : ')
-            CALL prt_ctl(tab2d_1=sm_i  (:,:,jl)   , clinfo1= ' lim_itd_me  : sm_i     : ')
-            CALL prt_ctl(tab2d_1=smv_i (:,:,jl)   , clinfo1= ' lim_itd_me  : smv_i    : ')
-            DO jk = 1, nlay_i
-               CALL prt_ctl_info(' ')
-               CALL prt_ctl_info(' - Layer : ', ivar1=jk)
-               CALL prt_ctl_info('   ~~~~~~~')
-               CALL prt_ctl(tab2d_1=t_i(:,:,jk,jl) , clinfo1= ' lim_itd_me  : t_i      : ')
-               CALL prt_ctl(tab2d_1=e_i(:,:,jk,jl) , clinfo1= ' lim_itd_me  : e_i      : ')
-            END DO
-         END DO
-      ENDIF
-
       ! conservation test
-      IF( ln_limdiahsb ) CALL lim_cons_hsm(1, 'limitd_me', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
-
-      ENDIF  ! ln_limdyn=.true.
-      !
+      IF( ln_limdiachk ) CALL lim_cons_hsm(1, 'limitd_me', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+
+      ! control prints
+      IF( ln_ctl )       CALL lim_prt3D( 'limitd_me' )
+
       CALL wrk_dealloc( jpi, jpj, closing_net, divu_adv, opning, closing_gross )
       !
@@ -368,5 +326,5 @@
                rswitch = MAX( 0._wp , SIGN( 1._wp, a_i(ji,jj,jl) - epsi20 ) )
                ht_i(ji,jj,jl) = v_i (ji,jj,jl) / MAX( a_i(ji,jj,jl) , epsi20 ) * rswitch
-            END DO
+           END DO
          END DO
       END DO
@@ -438,5 +396,6 @@
       ENDIF
 
-      IF( ln_rafting ) THEN      ! Ridging and rafting ice participation functions
+      ! --- Ridging and rafting participation concentrations --- !
+      IF( ln_rafting .AND. ln_ridging ) THEN
          !
          DO jl = 1, jpl
@@ -445,13 +404,19 @@
                   zdummy           = TANH ( rn_craft * ( ht_i(ji,jj,jl) - rn_hraft ) )
                   aridge(ji,jj,jl) = ( 1._wp + zdummy ) * 0.5_wp * athorn(ji,jj,jl)
-                  araft (ji,jj,jl) = ( 1._wp - zdummy ) * 0.5_wp * athorn(ji,jj,jl)
+                  araft (ji,jj,jl) = athorn(ji,jj,jl) - aridge(ji,jj,jl)
                END DO
             END DO
          END DO
-
-      ELSE
+         !
+      ELSEIF( ln_ridging .AND. .NOT. ln_rafting ) THEN
          !
          DO jl = 1, jpl
             aridge(:,:,jl) = athorn(:,:,jl)
+         END DO
+         !
+      ELSEIF( ln_rafting .AND. .NOT. ln_ridging ) THEN
+         !
+         DO jl = 1, jpl
+            araft(:,:,jl) = athorn(:,:,jl)
          END DO
          !
@@ -657,5 +622,5 @@
                   &                            - sm_i(ji,jj,jl1) * vsw(ij) * rhoic * r1_rdtice     ! and get  sm_i  from the ocean 
             ENDIF
-            
+               
             !------------------------------------------            
             ! 3.7 Put the snow somewhere in the ocean
@@ -795,8 +760,9 @@
       INTEGER             ::   numts_rm    ! number of time steps for the P smoothing
       REAL(wp)            ::   zp, z1_3    ! local scalars
-      REAL(wp), POINTER, DIMENSION(:,:) ::   zworka   ! temporary array used here
+      REAL(wp), POINTER, DIMENSION(:,:) ::   zworka           ! temporary array used here
+      REAL(wp), POINTER, DIMENSION(:,:) ::   zstrp1, zstrp2   ! strength at previous time steps
       !!----------------------------------------------------------------------
 
-      CALL wrk_alloc( jpi, jpj, zworka )
+      CALL wrk_alloc( jpi,jpj, zworka, zstrp1, zstrp2 )
 
       !------------------------------------------------------------------------------!
@@ -844,14 +810,14 @@
          END DO
    
-         strength(:,:) = rn_pe_rdg * Cp * strength(:,:) / aksum(:,:)
+         strength(:,:) = rn_pe_rdg * Cp * strength(:,:) / aksum(:,:) * tmask(:,:,1)
                          ! where Cp = (g/2)*(rhow-rhoi)*(rhoi/rhow) and rn_pe_rdg accounts for frictional dissipation
          ksmooth = 1
 
-         !------------------------------------------------------------------------------!
-         ! 4) Hibler (1979)' method
-         !------------------------------------------------------------------------------!
+      !------------------------------------------------------------------------------!
+      ! 4) Hibler (1979)' method
+      !------------------------------------------------------------------------------!
       ELSE                      ! kstrngth ne 1:  Hibler (1979) form
          !
-         strength(:,:) = rn_pstar * vt_i(:,:) * EXP( - rn_crhg * ( 1._wp - at_i(:,:) )  )
+         strength(:,:) = rn_pstar * vt_i(:,:) * EXP( - rn_crhg * ( 1._wp - at_i(:,:) )  ) * tmask(:,:,1)
          !
          ksmooth = 1
@@ -866,5 +832,5 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               strength(ji,jj) = strength(ji,jj) * exp(-5.88*SQRT(MAX(bv_i(ji,jj),0.0)))
+               strength(ji,jj) = strength(ji,jj) * exp(-5.88*SQRT(MAX(bvm_i(ji,jj),0.0)))
             END DO
          END DO
@@ -880,9 +846,7 @@
       IF ( ksmooth == 1 ) THEN
 
-         CALL lbc_lnk( strength, 'T', 1. )
-
          DO jj = 2, jpjm1
             DO ji = 2, jpim1
-               IF ( ( asum(ji,jj) - ato_i(ji,jj) ) > 0._wp) THEN 
+               IF ( ( asum(ji,jj) - ato_i(ji,jj) ) > 0._wp ) THEN 
                   zworka(ji,jj) = ( 4.0 * strength(ji,jj)              &
                      &                  + strength(ji-1,jj) * tmask(ji-1,jj,1) + strength(ji+1,jj) * tmask(ji+1,jj,1) &  
@@ -907,33 +871,30 @@
       ! Temporal smoothing
       !--------------------
-      IF ( numit == nit000 + nn_fsbc - 1 ) THEN
-         strp1(:,:) = 0.0            
-         strp2(:,:) = 0.0            
-      ENDIF
-
       IF ( ksmooth == 2 ) THEN
 
-         CALL lbc_lnk( strength, 'T', 1. )
-
-         DO jj = 1, jpj - 1
-            DO ji = 1, jpi - 1
-               IF ( ( asum(ji,jj) - ato_i(ji,jj) ) > 0._wp) THEN 
+         IF ( numit == nit000 + nn_fsbc - 1 ) THEN
+            zstrp1(:,:) = 0._wp
+            zstrp2(:,:) = 0._wp
+         ENDIF
+
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               IF ( ( asum(ji,jj) - ato_i(ji,jj) ) > 0._wp ) THEN 
                   numts_rm = 1 ! number of time steps for the running mean
-                  IF ( strp1(ji,jj) > 0._wp ) numts_rm = numts_rm + 1
-                  IF ( strp2(ji,jj) > 0._wp ) numts_rm = numts_rm + 1
-                  zp = ( strength(ji,jj) + strp1(ji,jj) + strp2(ji,jj) ) / numts_rm
-                  strp2(ji,jj) = strp1(ji,jj)
-                  strp1(ji,jj) = strength(ji,jj)
+                  IF ( zstrp1(ji,jj) > 0._wp ) numts_rm = numts_rm + 1
+                  IF ( zstrp2(ji,jj) > 0._wp ) numts_rm = numts_rm + 1
+                  zp = ( strength(ji,jj) + zstrp1(ji,jj) + zstrp2(ji,jj) ) / numts_rm
+                  zstrp2(ji,jj) = zstrp1(ji,jj)
+                  zstrp1(ji,jj) = strength(ji,jj)
                   strength(ji,jj) = zp
-
                ENDIF
             END DO
          END DO
 
+         CALL lbc_lnk( strength, 'T', 1. )      ! Boundary conditions
+
       ENDIF ! ksmooth
 
-      CALL lbc_lnk( strength, 'T', 1. )      ! Boundary conditions
-
-      CALL wrk_dealloc( jpi, jpj, zworka )
+      CALL wrk_dealloc( jpi,jpj, zworka, zstrp1, zstrp2 )
       !
    END SUBROUTINE lim_itd_me_icestrength
@@ -953,7 +914,6 @@
       !!-------------------------------------------------------------------
       INTEGER :: ios                 ! Local integer output status for namelist read
-      NAMELIST/namiceitdme/ rn_cs, rn_fsnowrdg, rn_fsnowrft,              & 
-        &                   rn_gstar, rn_astar, rn_hstar, ln_rafting, rn_hraft, rn_craft, rn_por_rdg, &
-        &                   nn_partfun
+      NAMELIST/namiceitdme/ rn_cs, nn_partfun, rn_gstar, rn_astar,             & 
+        &                   ln_ridging, rn_hstar, rn_por_rdg, rn_fsnowrdg, ln_rafting, rn_hraft, rn_craft, rn_fsnowrft
       !!-------------------------------------------------------------------
       !
@@ -969,17 +929,18 @@
       IF (lwp) THEN                          ! control print
          WRITE(numout,*)
-         WRITE(numout,*)' lim_itd_me_init : ice parameters for mechanical ice redistribution '
-         WRITE(numout,*)' ~~~~~~~~~~~~~~~'
+         WRITE(numout,*)'lim_itd_me_init : ice parameters for mechanical ice redistribution '
+         WRITE(numout,*)'~~~~~~~~~~~~~~~'
          WRITE(numout,*)'   Fraction of shear energy contributing to ridging        rn_cs       = ', rn_cs 
-         WRITE(numout,*)'   Fraction of snow volume conserved during ridging        rn_fsnowrdg = ', rn_fsnowrdg 
-         WRITE(numout,*)'   Fraction of snow volume conserved during ridging        rn_fsnowrft = ', rn_fsnowrft 
+         WRITE(numout,*)'   Switch for part. function (0) linear (1) exponential    nn_partfun  = ', nn_partfun
          WRITE(numout,*)'   Fraction of total ice coverage contributing to ridging  rn_gstar    = ', rn_gstar
          WRITE(numout,*)'   Equivalent to G* for an exponential part function       rn_astar    = ', rn_astar
+         WRITE(numout,*)'   Ridging of ice sheets or not                            ln_ridging  = ', ln_ridging
          WRITE(numout,*)'   Quantity playing a role in max ridged ice thickness     rn_hstar    = ', rn_hstar
+         WRITE(numout,*)'   Initial porosity of ridges                              rn_por_rdg  = ', rn_por_rdg
+         WRITE(numout,*)'   Fraction of snow volume conserved during ridging        rn_fsnowrdg = ', rn_fsnowrdg 
          WRITE(numout,*)'   Rafting of ice sheets or not                            ln_rafting  = ', ln_rafting
          WRITE(numout,*)'   Parmeter thickness (threshold between ridge-raft)       rn_hraft    = ', rn_hraft
          WRITE(numout,*)'   Rafting hyperbolic tangent coefficient                  rn_craft    = ', rn_craft  
-         WRITE(numout,*)'   Initial porosity of ridges                              rn_por_rdg  = ', rn_por_rdg
-         WRITE(numout,*)'   Switch for part. function (0) linear (1) exponential    nn_partfun  = ', nn_partfun
+         WRITE(numout,*)'   Fraction of snow volume conserved during ridging        rn_fsnowrft = ', rn_fsnowrft 
       ENDIF
       !
Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90	(revision 7309)
@@ -18,5 +18,4 @@
    !!   lim_itd_shiftice :
    !!----------------------------------------------------------------------
-   USE dom_ice          ! LIM-3 domain
    USE par_oce          ! ocean parameters
    USE dom_oce          ! ocean domain
